#!/usr/bin/env python3
import os
import subprocess
import csv

def main():
    # Username:Password:User ID:Group ID:User Info:Home Directory:Default Shell
    #linxintao:x:19132:191112:201921135048:/home/linxintao:/bin/bash

    lists = [['class_id', 'student_id', 'chinese_name', 'score', 'comment']]
    # Step 1: read file
    with open('/etc/passwd', 'r') as f:
        for line in f.readlines():
            l = line.strip().split(':')

            username = l[0]
            uid = int(l[2])
            gid = int(l[3])
            user_info = l[4]
            home_dir = l[5]


            # Step 2: get scores
            #if gid == 201112  and username=='qiankun': 
            #if gid == 201112:
            

            #if gid == 201112 and username not in ['u202021121045', 'qiankun']:
            #if gid == 201112 and username not in ['u202021121027', 'qiankun']:
            if gid == 201112 and username not in ['', 'qiankun']:
                print(user_info)
                #计算2012-202021121057-雷灿辉
                class_id, student_id, chinese_name = user_info.split('-')

                ## empty source file
                filename = os.path.join(home_dir, 'os_exp/exp4_sync_pv/process_synchronization_pv.c')
                original_filename = '/home/qiankun/os_exp/exp4_sync_pv/process_synchronization_pv.c'

                filename2 = os.path.join(home_dir, 'os_exp/exp4_sync_pv/semaphore.h')
                original_filename2 = '/home/qiankun/os_exp/exp4_sync_pv/semaphore.h'
                if os.stat(filename).st_size == os.stat(original_filename).st_size and \
                    os.stat(filename2).st_size == os.stat(original_filename2).st_size:
                    lists.append([class_id, student_id, chinese_name, 0, 'Nothing added'])
                    #print(class_id, student_id, chinese_name)
                    continue

                ## excute hello
                program = os.path.join(home_dir, 'os_exp/exp4_sync_pv/process_synchronization_pv')

                try:
                    output = subprocess.check_output([program], stderr=subprocess.STDOUT)
                # If returncode is non-zero, raise a CalledProcessError.
                except OSError as e:
                    if e.errno == 2:
                        lists.append([class_id, student_id, chinese_name, 0, 'no executable file'])
                        continue
                except subprocess.CalledProcessError as e:
                    lists.append([class_id, student_id, chinese_name, 0, str(e)])
                    continue

                # run correct
                try:
                    l = output.strip().decode().split()
                    if l[1] == l[2]:
                        lists.append([class_id, student_id, chinese_name, 10, 'Match'])
                    else:
                        lists.append([class_id, student_id, chinese_name, 0, 'Wrong output: {}'.format(output)])
                except Exception as e:
                    lists.append([class_id, student_id, chinese_name, 0, str(e)])


        # Step 3: write to file
        with open('exp4_scores_2022.csv', 'w') as f:
            writer = csv.writer(f)
            writer.writerows(lists)


if __name__ == '__main__':
    main()
